/****************************************************************************
 * Copyright (c) 1990-2000 Digi International Inc., All Rights Reserved
 *
 * This software contains proprietary and confidential information of Digi
 * International Inc.  By accepting transfer of this copy, Recipient agrees
 * to retain this software in confidence, to prevent disclosure to others,
 * and to make no use of this software other than that for which it was
 * delivered.  This is an unpublished copyrighted work of Digi International
 * Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
 * prohibited.
 *
 * Restricted Rights Legend
 *
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7031 or
 * subparagraphs (c)(1) and (2) of the Commercial Computer Software -
 * Restricted Rights at 48 CFR 52.227-19, as applicable.
 *
 * Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
 *
 ****************************************************************************
 *
 * Module Name:
 *
 *  dxbuser.h
 *
 * Abstract:
 *
 *  Include file for usermode wrapper routines for dxb streams api
 *  requests on Linux.
 *
 *  Written specifically for Tropico to provide dxb to userland for their
 *  specific needs.
 *
 * Author:
 *
 *  Jeff Randall, based upon dsuser.c by Mike Zarns and rawdxb.c
 */


#define RAW_DXB_DEVICE		"/dev/dg/dgdm/dxbStrm%d_%02d"
#define RAW_DXB_DEVICE_NAMELEN	128

#define OPEN_BUFFER_DATA_SIZE	512
#define MSG_BUFFER_DATA_SIZE	8192
#define DEBUG_BUFFER_SIZE	8192


int dxb_open_dev(int brd, char *devnm, int maxsize, int datasz, char *data);
int dxb_close_dev(int fd);
int dxb_putmsg(int fd, struct strbuf *cbuf, struct strbuf *dbuf, int flags);
int dxb_getmsg(int fd, struct strbuf *cbuf, struct strbuf *dbuf, int *flags);
int dxb_ioctl(int fd, struct strioctl *sioctl);
int dxb_flush(int fd);
