/*****************************************************************************
 * Copyright (c) 1988-95 Digi International Inc., All Rights Reserved
 * 
 * This  software  contains  proprietary  and  confidential   information   of
 * Digi International  Inc.   By  accepting  transfer  of this copy, Recipient
 * agrees to retain this software in  confidence,  to  prevent  disclosure  to
 * others,  and  to make no  use of this software other than that for which it
 * was delivered.  This is an unpublished copyright work  Digi   International
 * Inc.    Except   as   permitted   by  federal  law,  17 USC 117, copying is
 * strictly prohibited.
 * 
 * Digi  International  Inc.  CONFIDENTIAL  -   (Digi    International    Inc.
 * Confidential  when   combined   with   the   aggregated  modules  for  this
 * product) OBJECT CODE ONLY SOURCE MATERIALS
 * 
 * (C) COPYRIGHT Digi International Inc. 1995
 * 
 * All Rights Reserved
 * 
 * US   Government   Users   Restricted   Rights   -   Use,   duplication   or
 * disclosure  restricted by GSA ADP Schedule Contract with Digi International
 * Inc.
 * 
 *****************************************************************************/

/*
 * Copyright (c) 1993 Spider Systems Limited
 *
 * This Source Code is furnished under Licence, and may not be
 * copied or distributed without express written agreement.
 *
 * All rights reserved.  Made in Scotland.
 *
 * Authors: Angus Grossart
 *
 * lmi_errno.h of snet module
 *
 * SpiderISDN
 * Release 3.0.0 94/12/20
 * 
 * SpiderISDN Release 3 - Official Release.
 */

/* 
 * lmi_errno.h - common header for LMI and LMSI user
 * ==================================
 * This header file contains the result codes of managed objects 
 * controlled by LMSI messages.
 *
 */

#ifndef _SYS_SNET_LMI_ERRNO_
#define _SYS_SNET_LMI_ERRNO_

/*
 * Individual error codes for AVL tuples.
 */

#define AVL_OK		0	/* Successful */
#define AVL_E_ATTR	1	/* A non-existent/unknown attribute */
#define AVL_E_INST	2	/* A non-existent/unknown object instance */
#define AVL_E_CLASS	3	/* A non-existent/unknown object class */
#define AVL_E_RDONLY	4	/* A read only attribute values	*/
#define AVL_E_WRONLY	5	/* A write only attribute value	*/
#define AVL_E_SYSERR	6	/* A system error occurred */
#define AVL_E_TEMP      7       /* A temporary error */

/* 
 * One the following AVL error codes are set on downstream operations
 */
#define AVL_REPLACE	8	/* Perform attribute replace operation */
#define AVL_ADD		9	/* Perform attribute set addition */
#define AVL_REMOVE	10	/* Perform attribute remove */
#define AVL_DEFAULT	11	/* Perform set attribute default operation */

#endif
