
/*
 Copyright 1999 by Digi International (www.digi.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED; without even the 
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * rasmon.h
 */

#include "mgmtshim.h"
#include "mgmtdflt.h"
#include "mgmtioc1.h"
#include "dxbglbl.h"

union mgmt_request_primitives {
	getset_port_data_trc_t q_gs_dchan_data_trc;
	getset_channel_data_trc_t q_gs_bchan_data_trc;
	getset_channel_data_trc_t q_gs_serial_trc;
	getset_serial_status_trc_t q_gs_serial_status_trc;
};

union mgmt_response_primitives {
	getset_channel_data_trc_t r_gainfo;
};

/* We don't actually send this structure down, but since ras_trace.c
 * was originally developed using this structure, we'll use it for
 * passing info among routines.
 */

typedef struct mgmt_hd
{
	uint32	boardno;	// board number SEEMS TO BE USELESS
	uint16	command;	// command being sent
	uint16	mpkt_len;	// length of associated command structure
	uint16	rpkt_len;	// length of associated command response structure
	uint8	errorcode;	// associated command response error code
						// set by the driver
	uint8	hd_size;	// size of this header structure.
}mgmt_hd_t;

/* 
 * We define this structure also for internal purposes only
 */

typedef struct mgmt_msg
{
	mgmt_hd_t	hd;		// header structure
	union mgmt_request_primitives rq; // request structure
}mgmt_req_t;

