#include <dlfcn.h>

#include "dxbtypes.h"
#include "mgmtshim.h"
#include "mgmthlc.h"

char *mgmtErrorTbl[ ] =
{
	"ok",
	"bad command",
	"bad dfc",
	"bad parameter",
	"bad device",
	"out of memory",
	"unknown",
	"bad packet size",
	"no boards",
	"not initialized",
	"operation timeout",
	"internal",
	"serialize fail",
	"board not functional",
	"no mgmt chain"
};

int
main( )
{
	int status;
	int i;

	int board;

/**** GET_MGMT_BOARD_NO ****/

#if 1
	{
		get_mgmt_board_no_response_t buffer;

		printf( "GET_MGMT_BOARD_NO\n" );
	
		board = -1;
	
		status = MgmtCommand( 0, GET_MGMT_BOARD_NO,
			0, 0,
			&buffer, sizeof(buffer) );

		printf( "status: %d\n", status );

		if ( status != 0 )
			printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
		else
			printf( "NumberOfBoards: %d\n", buffer.NumberOfBoards );

		printf( "\n" );
	}
#endif

/**** GET_MGMT_PROTOCOL_VERSION ****/

#if 0
	{
		int i;

		get_mgmt_protocol_ver_response_t buffer;

		printf( "GET_MGMT_PROTOCOL_VERSION\n" );

		board = 1;

		status = MgmtCommand( board, GET_MGMT_PROTOCOL_VERSION,
			0, 0,
			&buffer, sizeof(buffer) );

		printf( "status: %d\n", status );

		if ( status != 0 )
			printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
		else
			printf( "version: %d\n", buffer.mgmt_protocol_version );

		printf( "\n" );
	}
#endif

	{
		get_mgmt_drv_vers_response_t buffer;

		printf( "GET_MGMT_VERS_INFO\n" );

		board = 1;

		status = MgmtCommand( board, GET_MGMT_DRV_VERS,
			0, 0,
			&buffer, sizeof(buffer) );

		printf( "status: %d\n", status );

		if ( status != 0 )
			printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
		else
		{
			printf( "Driver Count: %d\n", buffer.versions.driverCount );
			for (i=0; i<buffer.versions.driverCount; i++) {
				printf( "Driver %d: %s : ", i+1, buffer.versions.drivers[i].name );
				printf( "%s\n", buffer.versions.drivers[i].version );
			}
		}

		printf( "\n" );
	}
/**** GET_ADAPTER_INFO ****/

#if 0
	{
		get_adapter_info_response_t buffer;

		printf( "GET_ADAPTER_INFO\n" );

		board = 1;

		status = MgmtCommand( board, GET_ADAPTER_INFO,
			0, 0,
			&buffer, sizeof(buffer) );

		printf( "status: %d\n", status );

		if ( status != 0 )
			printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
		else
		{
			printf( "board_type: %d\n", buffer.info.board_type );
			printf( "port_count: %d\n", buffer.info.port_count );
			printf( "channels_per_port: %d\n", buffer.info.channels_per_port );
			printf( "memory_size: %d\n", buffer.info.memory_size );
			printf( "fep_version: %d\n", buffer.info.fep_version );
			printf( "csc_version: %d\n", buffer.info.csc_version );
			printf( "pump_version: %d\n", buffer.info.pump_version );
			printf( "main_board_revision: %d\n",
				buffer.info.main_board_revision );
			printf( "main_board_serial: %s\n", buffer.info.main_board_serial );
			printf( "daughter_card_revision: %d\n",
				buffer.info.daughter_card_revision );
			printf( "daughter_card_serial: %s\n",
				buffer.info.daughter_card_serial );
			printf( "part_number: %s\n", buffer.info.part_number );
		}

		printf( "\n" );
	}
#endif

#if 0
/**** GET_SERIAL_STATUS ****/

	{
		int i;

		union
		{
			get_serial_status_request_t req;
			get_serial_status_response_t rsp;
		} buffer;

		board = 1;

		printf( "GET_SERIAL_STATUS\n" );

		for ( i = 0; i < 2; i++ )
		{
			buffer.req.channel = i;

			status = MgmtCommand( board, GET_SERIAL_STATUS,
				&buffer, sizeof(buffer),
				&buffer, sizeof(buffer) );

			printf( "status: %d\n", status );

			if ( status != 0 )
				printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
			else
			{
				printf( "port_state: %d\n", buffer.rsp.status.port_state );
				printf( "frame_mode: %d\n", buffer.rsp.status.frame_mode );
	
				printf( "in_flow_type: %d\n", buffer.rsp.status.in_flow_type );
				printf( "out_flow_type: %d\n",
					buffer.rsp.status.out_flow_type );
				printf( "in_flow_state: %d\n",
					buffer.rsp.status.in_flow_state );
				printf( "out_flow_state: %d\n",
					buffer.rsp.status.out_flow_state );

				printf( "mdm_sig_state[RTS]: %d\n",
					buffer.rsp.status.mdm_sig_state[0] );
				printf( "mdm_sig_state[CTS]: %d\n",
					buffer.rsp.status.mdm_sig_state[1] );
				printf( "mdm_sig_state[DTR]: %d\n",
					buffer.rsp.status.mdm_sig_state[2] );
				printf( "mdm_sig_state[DSR]: %d\n",
					buffer.rsp.status.mdm_sig_state[3] );
				printf( "mdm_sig_state[RI]: %d\n",
					buffer.rsp.status.mdm_sig_state[4] );
				printf( "mdm_sig_state[DCD]: %d\n",
					buffer.rsp.status.mdm_sig_state[5] );
				printf( "mdm_sig_state[PAD1]: %d\n",
					buffer.rsp.status.mdm_sig_state[6] );
				printf( "mdm_sig_state[PAD2]: %d\n",
					buffer.rsp.status.mdm_sig_state[7] );

				printf( "in_speed: %d\n", buffer.rsp.status.in_speed );
				printf( "out_speed: %d\n", buffer.rsp.status.out_speed );
				printf( "autobaud: %d\n", buffer.rsp.status.autobaud );

				printf( "data_bits: %d\n", buffer.rsp.status.data_bits );
				printf( "stop_bits: %d\n", buffer.rsp.status.stop_bits );
				printf( "parity: %d\n", buffer.rsp.status.parity );
			}

			printf( "\n" );
		}

		printf( "\n" );
	}
#endif

/**** GET_ALL_CALL_STATUS ****/

	{
		int i, j;

		union
		{
			get_all_call_status_request_t req;
			get_all_call_status_response_t rsp;
		} buffer;

		printf( "GET_ALL_CALL_STATUS\n" );

		board = 1;

		for ( i = 0; i < 1; i++ )
		{
			buffer.req.port = i;

			status = MgmtCommand( board, GET_ALL_CALL_STATUS,
				&buffer, sizeof(buffer),
				&buffer, sizeof(buffer) );

			printf( "status: %d\n", status );

			if ( status != 0 )
				printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
			else
			{
				printf( "count: %d\n", buffer.rsp.count );

				for ( j = 0; j < buffer.rsp.count; j++ )
				{

				printf( "j: %d\n", j );
				printf( "call_state: %d\n", buffer.rsp.status[j].call_state );
				printf( "call_type: %d\n", buffer.rsp.status[j].call_type );
				printf( "index: %d\n", buffer.rsp.status[j].index );
				printf( "timeslot: %d\n", buffer.rsp.status[j].timeslot );

				}
			}

			printf( "\n" );
		}

		printf( "\n" );
	}

/**** GET_MODEM_CONFIG ****/

#if 0
	{
		int i;

		union
		{
			get_modem_config_request_t req;
			get_modem_config_response_t rsp;
		} buffer;

		printf( "GET_MODEM_CONFIG\n" );

		board = 1;

		for ( i = 0; i < 8; i++ )
		{
			buffer.req.channel = i;

			status = MgmtCommand( board, GET_MODEM_CONFIG,
				0, 0,
				&buffer, sizeof(buffer) );

			printf( "status: %d\n", status );

			if ( status != 0 )
				printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
			else
			{
				printf( "answer_rings: %d\n", buffer.rsp.config.answer_rings );
				printf( "clid_enable: %d\n", buffer.rsp.config.clid_enable );
				printf( "max_rate: %d\n", buffer.rsp.config.max_rate );
				printf( "min_rate: %d\n", buffer.rsp.config.min_rate );
				printf( "hangup: %d\n", buffer.rsp.config.hangup );
				printf( "reset: %d\n", buffer.rsp.config.reset );
			}

			printf( "\n" );
		}

		printf( "\n" );
	}
#endif

/**** GET_MODEM_STATUS ****/

#if 0
	{
		int i;

		union
		{
			get_modem_status_request_t req;
			get_modem_status_response_t rsp;
		} buffer;

		printf( "GET_MODEM_STATUS\n" );

		board = 1;

		for ( i = 0; i < 8; i++ )
		{
			buffer.req.channel = i;

			status = MgmtCommand( board, GET_MODEM_STATUS,
				0, 0,
				&buffer, sizeof(buffer) );

			printf( "status: %d\n", status );

			if ( status != 0 )
				printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
			else
				;

			printf( "\n" );
		}

		printf( "\n" );
	}
#endif

/**** GET_DCHAN_STATUS ****/

#if 0
	{
		get_bchan_status_response_t buffer;

		printf( "GET_BCHAN_STATUS\n" );

		board = 1;

		status = MgmtCommand( board, GET_BCHAN_STATUS,
			0, 0,
			&buffer, sizeof(buffer) );

		printf( "status: %d\n", status );

		if ( status != 0 )
			printf( "MgmtCommand error: %s\n", mgmtErrorTbl[status] );
		else
			;

		printf( "\n" );
	}
#endif

	return 0;
}
