#ifdef SWIG
	%module tcldgdm
	%{

/*
 Copyright 1999 by Digi International (www.digi.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED; without even the 
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

		#include "hlctypes.h"
		#include "mgmtioc1.h"
		#include "mgmthlc.h"
		#include "mgmttigger.h"
		#include "mgmtdflt.h"
		#include "pci_ids.h"
		#include "mgmtcc.h"
		#include "drivercc.h"

		//
		//	Define and initialize the modem country code ID to
		//	modem country code name array
		//

		CC_NAME_PAIR cc_id2name[] = ISO_CC_NAME_PAIR_INIT;

		//
		//	Define and initialize the modem country code ID list
		//	for all of the different adapters
		//

		uint32 dfr_T1_cc_id_list [] = HOUSTON_T1_DRV_CC_LIST_INIT;
		uint32 dfr_E1_cc_id_list [] = HOUSTON_E1_DRV_CC_LIST_INIT;
		uint32 dfr_U_cc_id_list [] = LONDON_U_DRV_CC_LIST_INIT;
		uint32 dfr_ST_cc_id_list [] = LONDON_ST_DRV_CC_LIST_INIT;
		uint32 apr_daa0_cc_id_list [] = CHASKA_DAA0_DRV_CC_LIST_INIT;
		uint32 apr_daa1_cc_id_list [] = CHASKA_DAA1_DRV_CC_LIST_INIT;
		uint32 apr_daa2_cc_id_list [] = CHASKA_DAA2_DRV_CC_LIST_INIT;
		uint32 apr_daa3_cc_id_list [] = CHASKA_DAA3_DRV_CC_LIST_INIT;

		//
		//
 		//	Do a file open
		//

		int openfd(char *filename, int mode)
			{ return open(filename, mode); }

		//
		//	Do a file close
		//

		void closefd(int fd)
			{ close(fd); }

		//	Return a call_status_t for a given
		//	all_call_status_t and channel idx.
		call_status_t *all_call_status_t_status_var_get (
		 all_call_status_t *all_call_status,
		 int idx)
		{
			/* The max for idx is hard-coded as 30 in mgmthlc.h */
			if (idx > 30 || idx < 0)
				return (call_status_t *) 0;

			return (&(all_call_status->status[idx]));
		}

		//
		//	Return the number or sub_address or spid from an indexed
		//	bri_config_t bri_directory_t structure
		//

		char *bri_config_t_directory_var_get (bri_config_t *bri_config,
		 char *field, uint32 index)
		{

			if (index > MSN_MAX - 1)
				return ("Index too Large");

			if (strcmp (field, "number") == 0)
				return ((char *)&(bri_config->directory[index].number[0]));

			if (strcmp (field, "sub_address") == 0)
				return ((char *)&(bri_config->directory[index].sub_address[0]));

			if (strcmp (field, "spid") == 0)
				return ((char *)&(bri_config->directory[index].spid[0]));

			return ("Unknown field");

		}

		//
		//	Set a new number or sub_address or spid in an indexed
		//	bri_config_t bri_directory_t structure
		//

		void bri_config_t_directory_var_set (bri_config_t *bri_config,
		 char *field, uint32 index, char *data)
		{
			int len;

			if (index > MSN_MAX - 1) {

				printf ("index = %d, too large", index);

				return;
			}

			if ((len = strlen (data)) > DN_LIMIT ) {

				printf ("data = \"%s\" has len = %d, too long", data, len);

				return;

			}

			bri_config->dir_count = bri_config->dir_count | BRI_DIR_UPDATE;

			if (strcmp (field, "number") == 0) {
				strcpy ((char *)&(bri_config->directory[index].number[0]), data);
				return;
			}

			if (strcmp (field, "sub_address") == 0) {
				strcpy ((char *)&(bri_config->directory[index].sub_address[0]), data);
				return;
			}

			if (strcmp (field, "spid") == 0) {
				strcpy ((char *)&(bri_config->directory[index].spid[0]), data);
				return;
			}

			return;

		}

		//
		//	Return the number of seconds or mseconds from a 
		//	timestamp_t based on a string (char *) argument
		//

		uint32 adapter_state_t_uptime_var_get (
		 adapter_state_t *adapter_state, char *field)
		{
			if (strcmp(field, "mseconds") == 0)
				return (adapter_state->uptime.mseconds);
			if (strcmp(field, "seconds") == 0)
				return (adapter_state->uptime.seconds);

			return 0;
		}

		//
		//	Returns n-th element of mgm_sig_state
		//	from a serial_state_t
		//

		int serial_status_t_mdm_sig_state_var_get (
		 serial_status_t *serial_status, int n)
		{
			if (n > SERIAL_SIGNAL_MAX)
				return -1;
			else
				return (serial_status->mdm_sig_state[n]);
		}


		//
		//	Return the modem country code ID for a board type and index
		//

		uint32 get_cc_id (int adapter_type, int index)
		{

			switch (adapter_type) {

			case ADAPTER_HOU30:
			case ADAPTER_HOU60:
			case ADAPTER_HOU30cpci:
			case ADAPTER_HOU60cpci:

				if (index < (sizeof (dfr_E1_cc_id_list) / sizeof (uint32)))
					return (dfr_E1_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_HOU24:
			case ADAPTER_HOU48:
			case ADAPTER_HOU24cpci:
			case ADAPTER_HOU48cpci:

				if (index < (sizeof (dfr_T1_cc_id_list) / sizeof (uint32)))
					return (dfr_T1_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_LONU:

				if (index < (sizeof (dfr_U_cc_id_list) / sizeof (uint32)))
					return (dfr_U_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_LONST:

				if (index < (sizeof (dfr_ST_cc_id_list) / sizeof (uint32)))
					return (dfr_ST_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_CHASKA80:
			case ADAPTER_CHASKA40:

				if (index < (sizeof (apr_daa0_cc_id_list) / sizeof (uint32)))
					return (apr_daa0_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_CHASKA81:
			case ADAPTER_CHASKA41:

				if (index < (sizeof (apr_daa1_cc_id_list) / sizeof (uint32)))
					return (apr_daa1_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_CHASKA82:
			case ADAPTER_CHASKA42:

				if (index < (sizeof (apr_daa2_cc_id_list) / sizeof (uint32)))
					return (apr_daa2_cc_id_list [index]);
				else
					return (0);

			case ADAPTER_CHASKA83:
			case ADAPTER_CHASKA43:

				if (index < (sizeof (apr_daa3_cc_id_list) / sizeof (uint32)))
					return (apr_daa3_cc_id_list [index]);
				else
					return (0);

			}

			return (0);
		}

		//
		//	Return the modem country code name that matches the passed ID
		//

		char *cc2name(uint32 cc)
		{
			int i;

			for (i = 0; i < CC_NAME_PAIR_LEN (cc_id2name); ++i)
			{
				if ( cc == cc_id2name[i].country_code)
					return (cc_id2name[i].country_name);
			}

			return ("Unknown");

		}

		//	Return the tei_state for a given index
		uint32 dchan_ext_status_t_tei_state_var_get (
		 dchan_ext_status_t *dchan_ext_status, int idx)
		{
			if (idx > BRI_MAX_TEIS)
				return -1;

			return (dchan_ext_status->tei_state[idx]);
		}
		//	Return the bri_state for a given index
		uint32 bri_status_t_spid_state_var_get (
		 bri_status_t *bri_status, int idx)
		{
			if (idx > BRI_MAX_SPIDS)
				return -1;
			return (bri_status->spid_state[idx]);
		}
	%}

	%include "hlctypes.h"

	//
	//	Typemapes to tell swig how to copy certain arrays
	//
	%typemap(memberin) dxb_uint8 [ANY] {
		memcpy($target,$source,$dim0);
	}
	%typemap(memberin) dxb_uint32 [ANY] {
		memcpy($target,$source,$dim0*sizeof(dxb_uint32));
	}
	%typemap(memberin) signalling_t [ANY] {
		memcpy($target$source,$dim0*sizeof(signalling_t));
	}
	%typemap(memberin) bri_directory_t [ANY] {
		memcpy($target,$source,$dim0*sizeof(bri_directory_t));
	}
	%typemap(memberin) call_status_t [ANY] {
		memcpy($target,$source,$dim0*sizeof(call_status_t));
	}
	%typemap(memberin) modem_status_t [ANY] {
		memcpy($target,$source,$dim0*sizeof(modem_status_t));
	}
	%typemap(memberin) all_call_status_t [ANY] {
		memcpy($target,$source,$dim0*sizeof(all_call_status_t));
	}
	%typemap(memberin) ds1_ct1_sig_status_t [ANY] {
		memcpy($target,$source,$dim0*sizeof(ds1_ct1_sig_status_t));
	}

	%inline %{
		char *any2str(void *a) {
			return a;
		}
	%}

	int openfd(char *filename, int mode);
	int ioctl(int fd, int cmd, void *p);
	void closefd(int fd);

	call_status_t *all_call_status_t_status_var_get (
	 all_call_status_t *all_call_status,
	 int idx);
	void bri_config_t_directory_var_set (bri_config_t *bri_config,
	 char *field, uint32 index, char *data);

	char *bri_config_t_directory_var_get (bri_config_t *bri_config,
	 char *field, uint32 index);

	uint32 adapter_state_t_uptime_var_get (
	 adapter_state_t *adapter_state, char *field);

	int serial_status_t_mdm_sig_state_var_get (
	 serial_status_t *serial_status, int n);

	char *cc2name(uint32 cc);
	uint32 get_cc_id (int adapter_type, int index);

	uint32 dchan_ext_status_t_tei_state_var_get (
	 dchan_ext_status_t *dchan_ext_status, int idx);
	uint32 bri_status_t_spid_state_var_get (
                 bri_status_t *bri_status, int idx);

	%include "mgmtioc1.h"
	%include "mgmthlc.h"
	%include "mgmttigger.h"
	%include "mgmtcmds.h"
	%include "pci_ids.h"

	%include "enums"
#endif
