
/*
 Copyright 1999-2000 by Digi International (www.digi.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED; without even the 
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Routines for displaying ISDN Trace Data in the format presented in Ron
** Gredvig's specification of March 7, 1996.
**
** March 19, 1996 by C. Pansch
*/

#define YES 1
#define NO  0

#define OK  0
#define ERR -1

#include "tracelog.h"

/* flags for the isdn_dump flags argument */
#define IDF_MSG_HEADER    0x0001  /* Display column headings for message line */
#define IDF_HEX_DUMP      0x0002  /* Display hex dump of the entire ISDN frame*/
#define IDF_NO_ASCII_HEX_DUMP 0x0040 /* Suppress hex dump for TLF_TYPE_ASCII  */
                                     /*  records. */
#define IDF_INFO_HEADER   0x0004  /* Display column headings for information  */
                                  /*  elements (if IDF_INFO_ELEMENTS is set   */
                                  /*  and information elements are present)   */
#define IDF_INFO_ELEMENTS 0x0008  /* Display information elements for level 3 */
                                  /*  frames. */
#define IDF_WHITESPACE    0x0010  /* Adds a blank line to the end of output.  */
#define IDF_FILTER_L2     0x0020  /* This filter extracts layer 3 messages    */
                                  /*  from a full data link layer trace.  Data*/
                                  /*  link layer frames not containing layer 3*/
                                  /*  messages are discarded.   */

/* error returns */
#define ERR_NO_MEM  201 /* out_buf was not big enough to hold entire output */

extern int isdn_dump(TLF_HEADER *te,
             char *out_buf, long out_buf_size, int flags);


#define HEXDUMPLEN(datalen) (((((datalen) + 15) / 16) * 80) + 1)
extern int hex_dump(char *data, int datalen, char *outbuf, long outbuflen);
