/* ex:se ts=8 sw=8: */
/************************************************************
 * Copyright (c) 1988-2001 Digi International Inc., All Rights Reserved.
 * This software contains proprietary and confidential information of Digi
 * International Inc.  By accepting transfer of this copy, Recipient agrees
 * to retain this software in confidence, to prevent disclosure to others,
 * and to make no use of this software other than that for which it was
 * delivered.  This is an unpublished copyrighted work of Digi International
 * Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
 * prohibited.
 */

/*
 * This .h file is located in the triboot cvs module so that
 * triboot will compile.  The contents of this file really
 * belong in pci_ids.h which is normally fetched from 
 * an "o-matic" directory.  Until all of the fep releases
 * are updated to include the latest pci_ids.h, we need this
 * here.
 */

#ifndef S2K_4PP_PCI_NAME

/*
 *	Sync 2000 - PCI form/factor
 */

#define S2K_4PP_PCI_NAME	"DataFire Sync 2000 4P+ PCI"
#define S2K_4PP_PCI_TYPE FOUR_PORT+P_PLUS+FORM_PCI+ONE_DXB
#define S2K_4PP_PCI_DID 			0x001F

#define S2K_2PP_PCI_NAME	"DataFire Sync 2000 2P+ PCI"
#define S2K_2PP_PCI_TYPE TWO_PORT+P_PLUS+FORM_PCI+ONE_DXB
#define S2K_2PP_PCI_DID 			0x0020

#define S2K_4P_PCI_NAME	"DataFire Sync 2000 4P PCI"
#define S2K_4P_PCI_TYPE FOUR_PORT+FORM_PCI+ONE_DXB
#define S2K_4P_PCI_DID			0x0021

#define S2K_2P_PCI_NAME	"DataFire Sync 2000 2P PCI"
#define S2K_2P_PCI_TYPE TWO_PORT+FORM_PCI+ONE_DXB
#define S2K_2P_PCI_DID			0x0022

/*
 *	Sync 2000  - cPCI form/factor
 */

#define S2K_4PP_CPCI_NAME	"DataFire Sync 2000 4P+ cPCI"
#define S2K_4PP_CPCI_TYPE FOUR_PORT+P_PLUS+FORM_CPCI+ONE_DXB
#define S2K_4PP_CPCI_DID		0x003A

#define S2K_2PP_CPCI_NAME	"DataFire Sync 2000 2P+ cPCI"
#define S2K_2PP_CPCI_TYPE TWO_PORT+P_PLUS+FORM_CPCI+ONE_DXB
#define S2K_2PP_CPCI_DID		0x003B

#define S2K_4P_CPCI_NAME	"DataFire Sync 2000 4P cPCI"
#define S2K_4P_CPCI_TYPE FOUR_PORT+FORM_CPCI+ONE_DXB
#define S2K_4P_CPCI_DID		0x003C

#define S2K_2P_CPCI_NAME	"DataFire Sync 2000 2P cPCI"
#define S2K_2P_CPCI_TYPE TWO_PORT+FORM_CPCI+ONE_DXB
#define S2K_2P_CPCI_DID		0x003D

/*
 *	Sync 2000 T1/E1/PRI aka CSU/DSU  - PCI form/factor
 */

#define S2K_4PP_PRI_PCI_NAME	"DataFire Sync 2000 4P+ T1 E1 PRI PCI"
#define S2K_4PP_PRI_PCI_TYPE FOUR_PORT+P_PLUS+CSU_DSU+FORM_PCI+ONE_DXB
#define S2K_4PP_PRI_PCI_DID		0x0046

#define S2K_2PP_PRI_PCI_NAME	"DataFire Sync 2000 2P+ T1 E1 PRI PCI"
#define S2K_2PP_PRI_PCI_TYPE TWO_PORT+P_PLUS+CSU_DSU+FORM_PCI+ONE_DXB
#define S2K_2PP_PRI_PCI_DID		0x0047

#define S2K_4P_PRI_PCI_NAME	"DataFire Sync 2000 4P T1 E1 PRI PCI"
#define S2K_4P_PRI_PCI_TYPE FOUR_PORT+CSU_DSU+FORM_PCI+ONE_DXB
#define S2K_4P_PRI_PCI_DID		0x0048

#define S2K_2P_PRI_PCI_NAME	"DataFire Sync 2000 2P T1 E1 PRI PCI"
#define S2K_2P_PRI_PCI_TYPE TWO_PORT+CSU_DSU+FORM_PCI+ONE_DXB
#define S2K_2P_PRI_PCI_DID		0x0049

#define S2K_1P_PRI_PCI_NAME	"DataFire Sync 2000 1P T1 E1 PRI PCI"
#define S2K_1P_PRI_PCI_TYPE ONE_PORT+CSU_DSU+FORM_PCI+ONE_DXB
#define S2K_1P_PRI_PCI_DID		0x004a

/*
 *	Sync 2000 T1/E1/PRI aka CSU/DSU  - cPCI form/factor
 */

#define S2K_4PP_PRI_CPCI_NAME "DataFire Sync 2000 4P+ T1 E1 PRI cPCI"
#define S2K_4PP_PRI_CPCI_TYPE FOUR_PORT+P_PLUS+CSU_DSU+FORM_CPCI+ONE_DXB
#define S2K_4PP_PRI_CPCI_DID	0x0096

#define S2K_2PP_PRI_CPCI_NAME "DataFire Sync 2000 2P+ T1 E1 PRI cPCI"
#define S2K_2PP_PRI_CPCI_TYPE TWO_PORT+P_PLUS+CSU_DSU+FORM_CPCI+ONE_DXB
#define S2K_2PP_PRI_CPCI_DID	0x0094

#define S2K_4P_PRI_CPCI_NAME	"DataFire Sync 2000 4P T1 E1 PRI cPCI"
#define S2K_4P_PRI_CPCI_TYPE FOUR_PORT+CSU_DSU+FORM_CPCI+ONE_DXB
#define S2K_4P_PRI_CPCI_DID	0x0095

#define S2K_2P_PRI_CPCI_NAME	"DataFire Sync 2000 2P T1 E1 PRI cPCI"
#define S2K_2P_PRI_CPCI_TYPE TWO_PORT+CSU_DSU+FORM_CPCI+ONE_DXB
#define S2K_2P_PRI_CPCI_DID	0x0093

#define S2K_1P_PRI_CPCI_NAME	"DataFire Sync 2000 1P T1 E1 PRI cPCI"
#define S2K_1P_PRI_CPCI_TYPE ONE_PORT+CSU_DSU+FORM_CPCI+ONE_DXB
#define S2K_1P_PRI_CPCI_DID	0x0091

/*
 *	Sync 2000 - PMC form/factor
 */

#define S2K_2PP_PMC_NAME	"DataFire Sync 2000 2P+ PMC"
#define S2K_2PP_PMC_TYPE TWO_PORT+P_PLUS+FORM_PMC+ONE_DXB
#define S2K_2PP_PMC_DID	0x0080

#define S2K_2P_PMC_NAME	"DataFire Sync 2000 2P PMC"
#define S2K_2P_PMC_TYPE TWO_PORT+FORM_PMC+ONE_DXB
#define S2K_2P_PMC_DID	0x0081

/*
 *	Sync 2000 T1/E1/PRI aka CSU/DSU - PMC form/factor
 */

#define S2K_2PP_PRI_PMC_NAME	"DataFire Sync 2000 2P+ T1 E1 PRI PMC"
#define S2K_2PP_PRI_PMC_TYPE TWO_PORT+P_PLUS+CSU_DSU+FORM_PMC+ONE_DXB
#define S2K_2PP_PRI_PMC_DID 0x0082

#define S2K_2P_PRI_PMC_NAME	"DataFire Sync 2000 2P T1 E1 PRI PMC"
#define S2K_2P_PRI_PMC_TYPE TWO_PORT+CSU_DSU+FORM_PMC+ONE_DXB
#define S2K_2P_PRI_PMC_DID	0x0083

/*
 *	PCI ID Table structure
 */

typedef struct pci_ids {

	unsigned long	pci_id;	/* PCI ID for this adapter */
	char		*id_txt; /* #define text */
	char		*name;	/* Marketing board name */
	unsigned long	info;	/* Adapter info */
} Pci_Ids_t;

/*	Pci_Ids->info */

#define PORT_MASK	0x000000ff
#define ONE_PORT	0x00000001
#define TWO_PORT	0x00000002
#define FOUR_PORT	0x00000004
#define EIGHT_PORT	0x00000008
#define SIXTEEN_PORT	0x00000016

#define DXB_MASK	0x00000f00
#define DXB_SHIFT	8
#define ONE_DXB		0x00000100
#define TWO_DXB		0x00000200
#define FOUR_DXB	0x00000400
#define EIGHT_DXB	0x00000800

#define CSU_DSU		0x00001000
#define P_PLUS		0x00002000

#define FORM_MASK	0x000f0000
#define FORM_PCI	0x00010000
#define FORM_CPCI	0x00020000
#define FORM_PMC	0x00030000

/*
 *	PCI ID Table build entry macro
 */

#define BTE(a,b,c) {a,#a,b,c}

/*
 *	PCI ID Table initializer macro
 */

#define PCI_TBL_INIT { \
BTE(S2K_4PP_PCI_DID,S2K_4PP_PCI_NAME,S2K_4PP_PCI_TYPE), \
BTE(S2K_2PP_PCI_DID,S2K_2PP_PCI_NAME,S2K_2PP_PCI_TYPE), \
BTE(S2K_4P_PCI_DID,S2K_4P_PCI_NAME,S2K_4P_PCI_TYPE), \
BTE(S2K_2P_PCI_DID,S2K_2P_PCI_NAME,S2K_2P_PCI_TYPE), \
BTE(S2K_4PP_CPCI_DID,S2K_4PP_CPCI_NAME,S2K_4PP_CPCI_TYPE), \
BTE(S2K_2PP_CPCI_DID,S2K_2PP_CPCI_NAME,S2K_2PP_CPCI_TYPE), \
BTE(S2K_4P_CPCI_DID,S2K_4P_CPCI_NAME,S2K_4P_CPCI_TYPE), \
BTE(S2K_2P_CPCI_DID,S2K_2P_CPCI_NAME,S2K_2P_CPCI_TYPE), \
BTE(S2K_4PP_PRI_PCI_DID,S2K_4PP_PRI_PCI_NAME,S2K_4PP_PRI_PCI_TYPE), \
BTE(S2K_2PP_PRI_PCI_DID,S2K_2PP_PRI_PCI_NAME,S2K_2PP_PRI_PCI_TYPE), \
BTE(S2K_4P_PRI_PCI_DID,S2K_4P_PRI_PCI_NAME,S2K_4P_PRI_PCI_TYPE), \
BTE(S2K_2P_PRI_PCI_DID,S2K_2P_PRI_PCI_NAME,S2K_2P_PRI_PCI_TYPE), \
BTE(S2K_1P_PRI_PCI_DID,S2K_1P_PRI_PCI_NAME,S2K_1P_PRI_PCI_TYPE), \
BTE(S2K_4PP_PRI_CPCI_DID,S2K_4PP_PRI_CPCI_NAME,S2K_4PP_PRI_CPCI_TYPE), \
BTE(S2K_2PP_PRI_CPCI_DID,S2K_2PP_PRI_CPCI_NAME,S2K_2PP_PRI_CPCI_TYPE), \
BTE(S2K_4P_PRI_CPCI_DID,S2K_4P_PRI_CPCI_NAME,S2K_4P_PRI_CPCI_TYPE), \
BTE(S2K_2P_PRI_CPCI_DID,S2K_2P_PRI_CPCI_NAME,S2K_2P_PRI_CPCI_TYPE), \
BTE(S2K_1P_PRI_CPCI_DID,S2K_1P_PRI_CPCI_NAME,S2K_1P_PRI_CPCI_TYPE), \
BTE(S2K_2PP_PMC_DID,S2K_2PP_PMC_NAME,S2K_2PP_PMC_TYPE), \
BTE(S2K_2P_PMC_DID,S2K_2P_PMC_NAME,S2K_2P_PMC_TYPE), \
BTE(S2K_2PP_PRI_PMC_DID,S2K_2PP_PRI_PMC_NAME,S2K_2PP_PRI_PMC_TYPE), \
BTE(S2K_2P_PRI_PMC_DID,S2K_2P_PRI_PMC_NAME,S2K_2P_PRI_PMC_TYPE) \
}

#define CASE_S2K_DID \
	case S2K_4PP_PCI_DID:\
	case S2K_2PP_PCI_DID:\
	case S2K_4P_PCI_DID:\
	case S2K_2P_PCI_DID:\
	case S2K_4PP_CPCI_DID:\
	case S2K_2PP_CPCI_DID:\
	case S2K_4P_CPCI_DID:\
	case S2K_2P_CPCI_DID:\
	case S2K_4PP_PRI_PCI_DID:\
	case S2K_2PP_PRI_PCI_DID:\
	case S2K_4P_PRI_PCI_DID:\
	case S2K_2P_PRI_PCI_DID:\
	case S2K_1P_PRI_PCI_DID:\
	case S2K_4PP_PRI_CPCI_DID:\
	case S2K_2PP_PRI_CPCI_DID:\
	case S2K_4P_PRI_CPCI_DID:\
	case S2K_2P_PRI_CPCI_DID:\
	case S2K_1P_PRI_CPCI_DID:\
	case S2K_2PP_PMC_DID:\
	case S2K_2P_PMC_DID:\
	case S2K_2PP_PRI_PMC_DID:\
	case S2K_2P_PRI_PMC_DID

#if !defined(SOLARIS) && !defined(HPUX) && !defined(SCOUNIX)
inline static int is_s2k(int id) {
	switch(id)
	{
	CASE_S2K_DID :
		return 1;
	default:
		return 0;
	}
}
#else
static int is_s2k(int id) {
	switch(id)
	{
	CASE_S2K_DID :
		return 1;
	default:
		return 0;
	}
}
#endif

#endif

